aboutsummaryrefslogtreecommitdiffstats
path: root/rc.d
diff options
context:
space:
mode:
authorBill Nottingham <notting@redhat.com>2010-10-14 08:39:01 -0400
committerBill Nottingham <notting@redhat.com>2010-10-14 08:39:01 -0400
commitd746e2e825e77a4ff7a969c87b0597856e26490c (patch)
tree9fdd25dfa63a5ecdbae474f6b73049dad1e3cd19 /rc.d
parentf280984f691e0c3cbca2b31dad7a32a5c66ab51b (diff)
downloadinitscripts-d746e2e825e77a4ff7a969c87b0597856e26490c.tar
initscripts-d746e2e825e77a4ff7a969c87b0597856e26490c.tar.gz
initscripts-d746e2e825e77a4ff7a969c87b0597856e26490c.tar.bz2
initscripts-d746e2e825e77a4ff7a969c87b0597856e26490c.tar.xz
initscripts-d746e2e825e77a4ff7a969c87b0597856e26490c.zip
Revert "add systemd services"
This reverts commit f280984f691e0c3cbca2b31dad7a32a5c66ab51b. This will be reworked a bit and re-added.
Diffstat (limited to 'rc.d')
-rwxr-xr-xrc.d/rc.sysinit657
-rwxr-xr-xrc.d/rcS.d/010-hostname.sh11
-rwxr-xr-xrc.d/rcS.d/020-mountbasic.sh11
-rwxr-xr-xrc.d/rcS.d/030-welcome.sh28
-rwxr-xr-xrc.d/rcS.d/040-setmodprobe.sh14
-rwxr-xr-xrc.d/rcS.d/060-taskaffinity.sh15
-rwxr-xr-xrc.d/rcS.d/070-startudev.sh3
-rwxr-xr-xrc.d/rcS.d/080-devpts.sh15
-rwxr-xr-xrc.d/rcS.d/090-loadmodules.sh12
-rwxr-xr-xrc.d/rcS.d/100-kernelparam.sh7
-rwxr-xr-xrc.d/rcS.d/110-waitscan.sh4
-rwxr-xr-xrc.d/rcS.d/120-loaddmmod.sh8
-rwxr-xr-xrc.d/rcS.d/130-initcrypto1.sh7
-rwxr-xr-xrc.d/rcS.d/140-multipath.sh13
-rwxr-xr-xrc.d/rcS.d/150-dmraid.sh19
-rwxr-xr-xrc.d/rcS.d/160-mdraid.sh4
-rwxr-xr-xrc.d/rcS.d/170-lvm.sh7
-rwxr-xr-xrc.d/rcS.d/180-initcrypto2.sh7
-rwxr-xr-xrc.d/rcS.d/190-mountall.sh315
-rwxr-xr-xrc.d/rcS.d/200-quota.sh12
-rwxr-xr-xrc.d/rcS.d/210-selinuxrelabel.sh74
-rwxr-xr-xrc.d/rcS.d/220-random.sh28
-rwxr-xr-xrc.d/rcS.d/230-initcrypto3.sh7
-rwxr-xr-xrc.d/rcS.d/240-configure.sh39
-rwxr-xr-xrc.d/rcS.d/250-cleanup.sh57
-rwxr-xr-xrc.d/rcS.d/260-swap.sh8
-rwxr-xr-xrc.d/rcS.d/270-autoswap.sh16
-rwxr-xr-xrc.d/rcS.d/300-binfmtmisc.sh4
-rwxr-xr-xrc.d/rcS.d/310-autofsck.sh4
-rwxr-xr-xrc.d/rcS.d/320-getkey.sh8
-rwxr-xr-xrc.d/rcS.d/330-dmesg.sh6
-rwxr-xr-xrc.d/rcS.d/990-sysinitend.sh6
32 files changed, 655 insertions, 771 deletions
diff --git a/rc.d/rc.sysinit b/rc.d/rc.sysinit
index 777dae31..ff003e92 100755
--- a/rc.d/rc.sysinit
+++ b/rc.d/rc.sysinit
@@ -2,6 +2,659 @@
#
# /etc/rc.d/rc.sysinit - run once at boot time
#
-for i in /etc/rc.d/rcS.d/*.sh; do
- . $i
+# Taken in part from Miquel van Smoorenburg's bcheckrc.
+#
+
+HOSTNAME=$(/bin/hostname)
+
+set -m
+
+if [ -f /etc/sysconfig/network ]; then
+ . /etc/sysconfig/network
+fi
+if [ -z "$HOSTNAME" -o "$HOSTNAME" = "(none)" ]; then
+ HOSTNAME=localhost
+fi
+
+if [ ! -e /proc/mounts ]; then
+ mount -n -t proc /proc /proc
+ mount -n -t sysfs /sys /sys >/dev/null 2>&1
+fi
+if [ ! -d /proc/bus/usb ]; then
+ modprobe usbcore >/dev/null 2>&1 && mount -n -t usbfs /proc/bus/usb /proc/bus/usb
+else
+ mount -n -t usbfs /proc/bus/usb /proc/bus/usb
+fi
+
+. /etc/init.d/functions
+
+PLYMOUTH=
+[ -x /usr/bin/plymouth ] && PLYMOUTH=yes
+
+# Check SELinux status
+SELINUX_STATE=
+if [ -e "/selinux/enforce" ] && [ "$(cat /proc/self/attr/current)" != "kernel" ]; then
+ if [ -r "/selinux/enforce" ] ; then
+ SELINUX_STATE=$(cat "/selinux/enforce")
+ else
+ # assume enforcing if you can't read it
+ SELINUX_STATE=1
+ fi
+fi
+
+if [ -n "$SELINUX_STATE" ] && [ -x /sbin/restorecon ] && __fgrep " /dev " /proc/mounts >/dev/null 2>&1 ; then
+ /sbin/restorecon -R /dev 2>/dev/null
+fi
+
+disable_selinux() {
+ echo $"*** Warning -- SELinux is active"
+ echo $"*** Disabling security enforcement for system recovery."
+ echo $"*** Run 'setenforce 1' to reenable."
+ echo "0" > "/selinux/enforce"
+}
+
+relabel_selinux() {
+ # if /sbin/init is not labeled correctly this process is running in the
+ # wrong context, so a reboot will be required after relabel
+ AUTORELABEL=
+ . /etc/selinux/config
+ echo "0" > /selinux/enforce
+ [ -n "$PLYMOUTH" ] && plymouth --hide-splash
+
+ if [ "$AUTORELABEL" = "0" ]; then
+ echo
+ echo $"*** Warning -- SELinux ${SELINUXTYPE} policy relabel is required. "
+ echo $"*** /etc/selinux/config indicates you want to manually fix labeling"
+ echo $"*** problems. Dropping you to a shell; the system will reboot"
+ echo $"*** when you leave the shell."
+ sulogin
+
+ else
+ echo
+ echo $"*** Warning -- SELinux ${SELINUXTYPE} policy relabel is required."
+ echo $"*** Relabeling could take a very long time, depending on file"
+ echo $"*** system size and speed of hard drives."
+
+ /sbin/fixfiles -F restore > /dev/null 2>&1
+ fi
+ rm -f /.autorelabel
+ echo $"Unmounting file systems"
+ umount -a
+ mount -n -o remount,ro /
+ echo $"Automatic reboot in progress."
+ reboot -f
+}
+
+# Print a text banner.
+echo -en $"\t\tWelcome to "
+read -r system_release < /etc/system-release
+if [[ "$system_release" == *"Red Hat"* ]]; then
+ [ "$BOOTUP" = "color" ] && echo -en "\\033[0;31m"
+ echo -en "Red Hat"
+ [ "$BOOTUP" = "color" ] && echo -en "\\033[0;39m"
+ PRODUCT=$(sed "s/Red Hat \(.*\) release.*/\1/" /etc/system-release)
+ echo " $PRODUCT"
+elif [[ "$system_release" == *Fedora* ]]; then
+ [ "$BOOTUP" = "color" ] && echo -en "\\033[0;34m"
+ echo -en "Fedora"
+ [ "$BOOTUP" = "color" ] && echo -en "\\033[0;39m"
+ PRODUCT=$(sed "s/Fedora \(.*\) \?release.*/\1/" /etc/system-release)
+ echo " $PRODUCT"
+else
+ PRODUCT=$(sed "s/ release.*//g" /etc/system-release)
+ echo "$PRODUCT"
+fi
+
+# Only read this once.
+cmdline=$(cat /proc/cmdline)
+
+# Initialize hardware
+if [ -f /proc/sys/kernel/modprobe ]; then
+ if ! strstr "$cmdline" nomodules && [ -f /proc/modules ] ; then
+ sysctl -w kernel.modprobe="/sbin/modprobe" >/dev/null 2>&1
+ else
+ # We used to set this to NULL, but that causes 'failed to exec' messages"
+ sysctl -w kernel.modprobe="/bin/true" >/dev/null 2>&1
+ fi
+fi
+
+touch /dev/.in_sysinit >/dev/null 2>&1
+
+# Set default affinity
+if [ -x /bin/taskset ]; then
+ if strstr "$cmdline" default_affinity= ; then
+ for arg in $cmdline ; do
+ if [ "${arg##default_affinity=}" != "${arg}" ]; then
+ /bin/taskset -p ${arg##default_affinity=} 1
+ fi
+ done
+ fi
+fi
+
+nashpid=$(pidof nash 2>/dev/null)
+[ -n "$nashpid" ] && kill $nashpid >/dev/null 2>&1
+unset nashpid
+/sbin/start_udev
+
+# Load other user-defined modules
+for file in /etc/sysconfig/modules/*.modules ; do
+ [ -x $file ] && $file
done
+
+# Load modules (for backward compatibility with VARs)
+if [ -f /etc/rc.modules ]; then
+ /etc/rc.modules
+fi
+
+mount -n /dev/pts >/dev/null 2>&1
+[ -n "$SELINUX_STATE" ] && restorecon /dev/pts >/dev/null 2>&1
+
+# Configure kernel parameters
+update_boot_stage RCkernelparam
+sysctl -e -p /etc/sysctl.conf >/dev/null 2>&1
+
+# Set the hostname.
+update_boot_stage RChostname
+action $"Setting hostname ${HOSTNAME}: " hostname ${HOSTNAME}
+
+# Sync waiting for storage.
+{ rmmod scsi_wait_scan ; modprobe scsi_wait_scan ; rmmod scsi_wait_scan ; } >/dev/null 2>&1
+
+# Device mapper & related initialization
+if ! __fgrep "device-mapper" /proc/devices >/dev/null 2>&1 ; then
+ modprobe dm-mod >/dev/null 2>&1
+fi
+
+if [ -f /etc/crypttab ]; then
+ init_crypto 0
+fi
+
+if ! strstr "$cmdline" nompath && [ -f /etc/multipath.conf ] && \
+ [ -x /sbin/multipath ]; then
+ modprobe dm-multipath > /dev/null 2>&1
+ /sbin/multipath -v 0
+ if [ -x /sbin/kpartx ]; then
+ /sbin/dmsetup ls --target multipath --exec "/sbin/kpartx -a -p p" >/dev/null
+ fi
+fi
+
+if ! strstr "$cmdline" nodmraid && [ -x /sbin/dmraid ]; then
+ modprobe dm-mirror >/dev/null 2>&1
+ dmraidsets=$(LC_ALL=C /sbin/dmraid -s -c -i)
+ if [ "$?" = "0" ]; then
+ for dmname in $dmraidsets; do
+ if [[ "$dmname" == isw_* ]] && \
+ ! strstr "$cmdline" noiswmd; then
+ continue
+ fi
+ /sbin/dmraid -ay -i --rm_partitions -p "$dmname" >/dev/null 2>&1
+ /sbin/kpartx -a -p p "/dev/mapper/$dmname"
+ done
+ fi
+fi
+
+# Start any MD RAID arrays that haven't been started yet
+[ -r /proc/mdstat -a -r /dev/md/md-device-map ] && /sbin/mdadm -IRs
+
+if [ -x /sbin/lvm ]; then
+ action $"Setting up Logical Volume Management:" /sbin/lvm vgchange -a y --sysinit
+fi
+
+if [ -f /etc/crypttab ]; then
+ init_crypto 0
+fi
+
+if [ -f /fastboot ] || strstr "$cmdline" fastboot ; then
+ fastboot=yes
+fi
+
+if [ -f /fsckoptions ]; then
+ fsckoptions=$(cat /fsckoptions)
+fi
+
+if [ -f /forcefsck ] || strstr "$cmdline" forcefsck ; then
+ fsckoptions="-f $fsckoptions"
+elif [ -f /.autofsck ]; then
+ [ -f /etc/sysconfig/autofsck ] && . /etc/sysconfig/autofsck
+ if [ "$AUTOFSCK_DEF_CHECK" = "yes" ]; then
+ AUTOFSCK_OPT="$AUTOFSCK_OPT -f"
+ fi
+ if [ -n "$AUTOFSCK_SINGLEUSER" ]; then
+ [ -n "$PLYMOUTH" ] && plymouth --hide-splash
+ echo
+ echo $"*** Warning -- the system did not shut down cleanly. "
+ echo $"*** Dropping you to a shell; the system will continue"
+ echo $"*** when you leave the shell."
+ [ -n "$SELINUX_STATE" ] && echo "0" > /selinux/enforce
+ sulogin
+ [ -n "$SELINUX_STATE" ] && echo "1" > /selinux/enforce
+ [ -n "$PLYMOUTH" ] && plymouth --show-splash
+ fi
+ fsckoptions="$AUTOFSCK_OPT $fsckoptions"
+fi
+
+if [ "$BOOTUP" = "color" ]; then
+ fsckoptions="-C $fsckoptions"
+else
+ fsckoptions="-V $fsckoptions"
+fi
+
+READONLY=
+if [ -f /etc/sysconfig/readonly-root ]; then
+ . /etc/sysconfig/readonly-root
+fi
+if strstr "$cmdline" readonlyroot ; then
+ READONLY=yes
+ [ -z "$RW_MOUNT" ] && RW_MOUNT=/var/lib/stateless/writable
+ [ -z "$STATE_MOUNT" ] && STATE_MOUNT=/var/lib/stateless/state
+fi
+if strstr "$cmdline" noreadonlyroot ; then
+ READONLY=no
+fi
+
+if [ "$READONLY" = "yes" -o "$TEMPORARY_STATE" = "yes" ]; then
+
+ mount_empty() {
+ if [ -e "$1" ]; then
+ echo "$1" | cpio -p -vd "$RW_MOUNT" &>/dev/null
+ mount -n --bind "$RW_MOUNT$1" "$1"
+ fi
+ }
+
+ mount_dirs() {
+ if [ -e "$1" ]; then
+ mkdir -p "$RW_MOUNT$1"
+ find "$1" -type d -print0 | cpio -p -0vd "$RW_MOUNT" &>/dev/null
+ mount -n --bind "$RW_MOUNT$1" "$1"
+ fi
+ }
+
+ mount_files() {
+ if [ -e "$1" ]; then
+ cp -a --parents "$1" "$RW_MOUNT"
+ mount -n --bind "$RW_MOUNT$1" "$1"
+ fi
+ }
+
+ # Common mount options for scratch space regardless of
+ # type of backing store
+ mountopts=
+
+ # Scan partitions for local scratch storage
+ rw_mount_dev=$(blkid -t LABEL="$RW_LABEL" -l -o device)
+
+ # First try to mount scratch storage from /etc/fstab, then any
+ # partition with the proper label. If either succeeds, be sure
+ # to wipe the scratch storage clean. If both fail, then mount
+ # scratch storage via tmpfs.
+ if mount $mountopts "$RW_MOUNT" > /dev/null 2>&1 ; then
+ rm -rf "$RW_MOUNT" > /dev/null 2>&1
+ elif [ x$rw_mount_dev != x ] && mount $rw_mount_dev $mountopts "$RW_MOUNT" > /dev/null 2>&1; then
+ rm -rf "$RW_MOUNT" > /dev/null 2>&1
+ else
+ mount -n -t tmpfs $RW_OPTIONS $mountopts none "$RW_MOUNT"
+ fi
+
+ for file in /etc/rwtab /etc/rwtab.d/* /dev/.initramfs/rwtab ; do
+ is_ignored_file "$file" && continue
+ [ -f $file ] && cat $file | while read type path ; do
+ case "$type" in
+ empty)
+ mount_empty $path
+ ;;
+ files)
+ mount_files $path
+ ;;
+ dirs)
+ mount_dirs $path
+ ;;
+ *)
+ ;;
+ esac
+ [ -n "$SELINUX_STATE" ] && [ -e "$path" ] && restorecon -R "$path"
+ done
+ done
+
+ # Use any state passed by initramfs
+ [ -d /dev/.initramfs/state ] && cp -a /dev/.initramfs/state/* $RW_MOUNT
+
+ # In theory there should be no more than one network interface active
+ # this early in the boot process -- the one we're booting from.
+ # Use the network address to set the hostname of the client. This
+ # must be done even if we have local storage.
+ ipaddr=
+ if [ "$HOSTNAME" = "localhost" -o "$HOSTNAME" = "localhost.localdomain" ]; then
+ ipaddr=$(ip addr show to 0.0.0.0/0 scope global | awk '/[[:space:]]inet / { print gensub("/.*","","g",$2) }')
+ for ip in $ipaddr ; do
+ HOSTNAME=
+ eval $(ipcalc -h $ipaddr 2>/dev/null)
+ [ -n "$HOSTNAME" ] && { hostname ${HOSTNAME} ; break; }
+ done
+ fi
+
+ # Clients with read-only root filesystems may be provided with a
+ # place where they can place minimal amounts of persistent
+ # state. SSH keys or puppet certificates for example.
+ #
+ # Ideally we'll use puppet to manage the state directory and to
+ # create the bind mounts. However, until that's all ready this
+ # is sufficient to build a working system.
+
+ # First try to mount persistent data from /etc/fstab, then any
+ # partition with the proper label, then fallback to NFS
+ state_mount_dev=$(blkid -t LABEL="$STATE_LABEL" -l -o device)
+ if mount $mountopts $STATE_OPTIONS "$STATE_MOUNT" > /dev/null 2>&1 ; then
+ /bin/true
+ elif [ x$state_mount_dev != x ] && mount $state_mount_dev $mountopts "$STATE_MOUNT" > /dev/null 2>&1; then
+ /bin/true
+ elif [ ! -z "$CLIENTSTATE" ]; then
+ # No local storage was found. Make a final attempt to find
+ # state on an NFS server.
+
+ mount -t nfs $CLIENTSTATE/$HOSTNAME $STATE_MOUNT -o rw,nolock
+ fi
+
+ if [ -w "$STATE_MOUNT" ]; then
+
+ mount_state() {
+ if [ -e "$1" ]; then
+ [ ! -e "$STATE_MOUNT$1" ] && cp -a --parents "$1" "$STATE_MOUNT"
+ mount -n --bind "$STATE_MOUNT$1" "$1"
+ fi
+ }
+
+ for file in /etc/statetab /etc/statetab.d/* ; do
+ is_ignored_file "$file" && continue
+ [ ! -f "$file" ] && continue
+
+ if [ -f "$STATE_MOUNT/$file" ] ; then
+ mount -n --bind "$STATE_MOUNT/$file" "$file"
+ fi
+
+ for path in $(grep -v "^#" "$file" 2>/dev/null); do
+ mount_state "$path"
+ [ -n "$SELINUX_STATE" ] && [ -e "$path" ] && restorecon -R "$path"
+ done
+ done
+
+ if [ -f "$STATE_MOUNT/files" ] ; then
+ for path in $(grep -v "^#" "$STATE_MOUNT/files" 2>/dev/null); do
+ mount_state "$path"
+ [ -n "$SELINUX_STATE" ] && [ -e "$path" ] && restorecon -R "$path"
+ done
+ fi
+ fi
+fi
+
+if [[ " $fsckoptions" != *" -y"* ]]; then
+ fsckoptions="-a $fsckoptions"
+fi
+
+_RUN_QUOTACHECK=0
+if strstr "$cmdline" forcequotacheck || [ -f /forcequotacheck ] ; then
+ _RUN_QUOTACHECK=1
+fi
+if [ -z "$fastboot" -a "$READONLY" != "yes" ]; then
+
+ STRING=$"Checking filesystems"
+ echo $STRING
+ fsck -T -t noopts=_netdev -A $fsckoptions
+ rc=$?
+
+ if [ "$rc" -eq "0" ]; then
+ success "$STRING"
+ echo
+ elif [ "$rc" -eq "1" ]; then
+ passed "$STRING"
+ echo
+ elif [ "$rc" -eq "2" -o "$rc" -eq "3" ]; then
+ echo $"Unmounting file systems"
+ umount -a
+ mount -n -o remount,ro /
+ echo $"Automatic reboot in progress."
+ reboot -f
+ fi
+
+ # A return of 4 or higher means there were serious problems.
+ if [ $rc -gt 1 ]; then
+ [ -n "$PLYMOUTH" ] && plymouth --hide-splash
+
+ failure "$STRING"
+ echo
+ echo
+ echo $"*** An error occurred during the file system check."
+ echo $"*** Dropping you to a shell; the system will reboot"
+ echo $"*** when you leave the shell."
+
+ str=$"(Repair filesystem)"
+ PS1="$str \# # "; export PS1
+ [ "$SELINUX_STATE" = "1" ] && disable_selinux
+ sulogin
+
+ echo $"Unmounting file systems"
+ umount -a
+ mount -n -o remount,ro /
+ echo $"Automatic reboot in progress."
+ reboot -f
+ elif [ "$rc" -eq "1" ]; then
+ _RUN_QUOTACHECK=1
+ fi
+fi
+
+remount_needed() {
+ local state oldifs
+ [ "$READONLY" = "yes" ] && return 1
+ state=$(LC_ALL=C awk '/ \/ / && ($3 !~ /rootfs/) { print $4 }' /proc/mounts)
+ oldifs=$IFS
+ IFS=","
+ for opt in $state ; do
+ if [ "$opt" = "rw" ]; then
+ IFS=$oldifs
+ return 1
+ fi
+ done
+ IFS=$oldifs
+ return 0
+}
+
+# Remount the root filesystem read-write.
+update_boot_stage RCmountfs
+if remount_needed ; then
+ action $"Remounting root filesystem in read-write mode: " mount -n -o remount,rw /
+fi
+
+# Clean up SELinux labels
+if [ -n "$SELINUX_STATE" ]; then
+ restorecon /etc/mtab /etc/ld.so.cache /etc/blkid/blkid.tab /etc/resolv.conf >/dev/null 2>&1
+fi
+
+# If relabeling, relabel mount points.
+if [ -n "$SELINUX_STATE" -a "$READONLY" != "yes" ]; then
+ if strstr "$cmdline" autorelabel || [ -f /.autorelabel ] ; then
+ restorecon $(awk '!/^#/ && $4 !~ /noauto/ && $2 ~ /^\// { print $2 }' /etc/fstab) >/dev/null 2>&1
+ fi
+fi
+
+if [ "$READONLY" != "yes" ] ; then
+ # Clear mtab
+ (> /etc/mtab) &> /dev/null
+
+ # Remove stale backups
+ rm -f /etc/mtab~ /etc/mtab~~
+
+ # Enter mounted filesystems into /etc/mtab
+ mount -f /
+ mount -f /proc >/dev/null 2>&1
+ mount -f /sys >/dev/null 2>&1
+ mount -f /dev/pts >/dev/null 2>&1
+ mount -f /dev/shm >/dev/null 2>&1
+ mount -f /proc/bus/usb >/dev/null 2>&1
+fi
+
+# Mount all other filesystems (except for NFS and /proc, which is already
+# mounted). Contrary to standard usage,
+# filesystems are NOT unmounted in single user mode.
+if [ "$READONLY" != "yes" ] ; then
+ action $"Mounting local filesystems: " mount -a -t nonfs,nfs4,smbfs,ncpfs,cifs,gfs,gfs2 -O no_netdev
+else
+ action $"Mounting local filesystems: " mount -a -n -t nonfs,nfs4,smbfs,ncpfs,cifs,gfs,gfs2 -O no_netdev
+fi
+
+# Update quotas if necessary
+if [ X"$_RUN_QUOTACHECK" = X1 ] && [ -x /sbin/quotacheck ]; then
+ action $"Checking local filesystem quotas: " /sbin/quotacheck -anug
+fi
+
+if [ -x /sbin/quotaon ]; then
+ action $"Enabling local filesystem quotas: " /sbin/quotaon -aug
+fi
+
+# Check to see if a full relabel is needed
+if [ -n "$SELINUX_STATE" -a "$READONLY" != "yes" ]; then
+ if strstr "$cmdline" autorelabel || [ -f /.autorelabel ] ; then
+ relabel_selinux
+ fi
+else
+ if [ "$READONLY" != "yes" ] && [ -d /etc/selinux ]; then
+ [ -f /.autorelabel ] || touch /.autorelabel
+ fi
+fi
+
+# Initialize pseudo-random number generator
+if [ -f "/var/lib/random-seed" ]; then
+ cat /var/lib/random-seed > /dev/urandom
+else
+ [ "$READONLY" != "yes" ] && touch /var/lib/random-seed
+fi
+if [ "$READONLY" != "yes" ]; then
+ chmod 600 /var/lib/random-seed
+ dd if=/dev/urandom of=/var/lib/random-seed count=1 bs=512 2>/dev/null
+fi
+
+if [ -f /etc/crypttab ]; then
+ init_crypto 1
+fi
+
+# Configure machine if necessary.
+if [ -f /.unconfigured ]; then
+ if [ -x /usr/bin/rhgb-client ] && /usr/bin/rhgb-client --ping ; then
+ /usr/bin/rhgb-client --quit
+ fi
+
+ if [ -x /usr/bin/system-config-keyboard ]; then
+ /usr/bin/system-config-keyboard
+ fi
+ if [ -x /usr/bin/passwd ]; then
+ /usr/bin/passwd root
+ fi
+ if [ -x /usr/sbin/system-config-network-tui ]; then
+ /usr/sbin/system-config-network-tui
+ fi
+ if [ -x /usr/sbin/timeconfig ]; then
+ /usr/sbin/timeconfig
+ fi
+ if [ -x /usr/sbin/authconfig-tui ]; then
+ /usr/sbin/authconfig-tui --nostart
+ fi
+ if [ -x /usr/sbin/ntsysv ]; then
+ /usr/sbin/ntsysv --level 35
+ fi
+
+ # Reread in network configuration data.
+ if [ -f /etc/sysconfig/network ]; then
+ . /etc/sysconfig/network
+
+ # Reset the hostname.
+ action $"Resetting hostname ${HOSTNAME}: " hostname ${HOSTNAME}
+ fi
+
+ rm -f /.unconfigured
+fi
+
+# Clean out /.
+rm -f /fastboot /fsckoptions /forcefsck /.autofsck /forcequotacheck /halt \
+ /poweroff /.suspended &> /dev/null
+
+# Do we need (w|u)tmpx files? We don't set them up, but the sysadmin might...
+_NEED_XFILES=
+[ -f /var/run/utmpx ] || [ -f /var/log/wtmpx ] && _NEED_XFILES=1
+
+# Clean up /var.
+rm -rf /var/lock/cvs/* /var/run/screen/*
+find /var/lock /var/run ! -type d -exec rm -f {} \;
+rm -f /var/lib/rpm/__db* &> /dev/null
+rm -f /var/gdm/.gdmfifo &> /dev/null
+
+# Clean up utmp/wtmp
+> /var/run/utmp
+touch /var/log/wtmp /var/log/btmp
+chgrp utmp /var/run/utmp /var/log/wtmp /var/log/btmp
+chmod 0664 /var/run/utmp /var/log/wtmp
+chmod 0600 /var/log/btmp
+if [ -n "$_NEED_XFILES" ]; then
+ > /var/run/utmpx
+ touch /var/log/wtmpx
+ chgrp utmp /var/run/utmpx /var/log/wtmpx
+ chmod 0664 /var/run/utmpx /var/log/wtmpx
+fi
+[ -n "$SELINUX_STATE" ] && restorecon /var/run/utmp* /var/log/wtmp* >/dev/null 2>&1
+
+# Clean up various /tmp bits
+[ -n "$SELINUX_STATE" ] && restorecon /tmp
+rm -f /tmp/.X*-lock /tmp/.lock.* /tmp/.gdm_socket /tmp/.s.PGSQL.*
+rm -rf /tmp/.X*-unix /tmp/.ICE-unix /tmp/.font-unix /tmp/hsperfdata_* \
+ /tmp/kde-* /tmp/ksocket-* /tmp/mc-* /tmp/mcop-* /tmp/orbit-* \
+ /tmp/scrollkeeper-* /tmp/ssh-* \
+ /dev/.in_sysinit
+
+# Make ICE directory
+mkdir -m 1777 -p /tmp/.ICE-unix >/dev/null 2>&1
+chown root:root /tmp/.ICE-unix
+[ -n "$SELINUX_STATE" ] && restorecon /tmp/.ICE-unix >/dev/null 2>&1
+
+# Start up swapping.
+update_boot_stage RCswap
+action $"Enabling /etc/fstab swaps: " swapon -a -e
+if [ "$AUTOSWAP" = "yes" ]; then
+ curswap=$(awk '/^\/dev/ { print $1 }' /proc/swaps | while read x; do get_numeric_dev dec $x ; echo -n " "; done)
+ swappartitions=$(blkid -t TYPE=swap -o device)
+ if [ x"$swappartitions" != x ]; then
+ for partition in $swappartitions ; do
+ [ ! -e $partition ] && continue
+ majmin=$(get_numeric_dev dec $partition)
+ echo $curswap | grep -qw "$majmin" || action $"Enabling local swap partitions: " swapon $partition
+ done
+ fi
+fi
+
+# Set up binfmt_misc
+/bin/mount -t binfmt_misc none /proc/sys/fs/binfmt_misc > /dev/null 2>&1
+
+# Boot time profiles. Yes, this should be somewhere else.
+if [ -x /usr/sbin/system-config-network-cmd ]; then
+ if strstr "$cmdline" netprofile= ; then
+ for arg in $cmdline ; do
+ if [ "${arg##netprofile=}" != "${arg}" ]; then
+ /usr/sbin/system-config-network-cmd --profile ${arg##netprofile=}
+ fi
+ done
+ fi
+fi
+
+# Now that we have all of our basic modules loaded and the kernel going,
+# let's dump the syslog ring somewhere so we can find it later
+[ -f /var/log/dmesg ] && mv -f /var/log/dmesg /var/log/dmesg.old
+dmesg -s 131072 > /var/log/dmesg
+
+# create the crash indicator flag to warn on crashes, offer fsck with timeout
+touch /.autofsck &> /dev/null
+
+if strstr "$cmdline" confirm ; then
+ touch /var/run/confirm
+fi
+
+# Let rhgb know that we're leaving rc.sysinit
+if [ -x /usr/bin/rhgb-client ] && /usr/bin/rhgb-client --ping ; then
+ /usr/bin/rhgb-client --sysinit
+fi
+
diff --git a/rc.d/rcS.d/010-hostname.sh b/rc.d/rcS.d/010-hostname.sh
deleted file mode 100755
index 713a3a37..00000000
--- a/rc.d/rcS.d/010-hostname.sh
+++ /dev/null
@@ -1,11 +0,0 @@
-#!/bin/sh
-HOSTNAME=$(/bin/hostname)
-
-if [ -f /etc/sysconfig/network ]; then
- . /etc/sysconfig/network
-fi
-if [ -z "$HOSTNAME" -o "$HOSTNAME" = "(none)" ]; then
- HOSTNAME=localhost
-fi
-hostname ${HOSTNAME}
-:
diff --git a/rc.d/rcS.d/020-mountbasic.sh b/rc.d/rcS.d/020-mountbasic.sh
deleted file mode 100755
index 9448be61..00000000
--- a/rc.d/rcS.d/020-mountbasic.sh
+++ /dev/null
@@ -1,11 +0,0 @@
-#!/bin/sh
-if [ ! -e /proc/mounts ]; then
- mount -n -t proc /proc /proc
- mount -n -t sysfs /sys /sys >/dev/null 2>&1
-fi
-if [ ! -d /proc/bus/usb ]; then
- modprobe usbcore >/dev/null 2>&1 && mount -n -t usbfs /proc/bus/usb /proc/bus/usb
-else
- mount -n -t usbfs /proc/bus/usb /proc/bus/usb
-fi
-:
diff --git a/rc.d/rcS.d/030-welcome.sh b/rc.d/rcS.d/030-welcome.sh
deleted file mode 100755
index e7d8248c..00000000
--- a/rc.d/rcS.d/030-welcome.sh
+++ /dev/null
@@ -1,28 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
-
-# Print a text banner.
-echo -en $"\t\tWelcome to "
-read -r system_release < /etc/system-release
-if [[ "$system_release" == *"Red Hat"* ]]; then
- [ "$BOOTUP" = "color" ] && echo -en "\\033[0;31m"
- echo -en "Red Hat"
- [ "$BOOTUP" = "color" ] && echo -en "\\033[0;39m"
- PRODUCT=$(sed "s/Red Hat \(.*\) release.*/\1/" /etc/system-release)
- echo " $PRODUCT"
-elif [[ "$system_release" == *Fedora* ]]; then
- [ "$BOOTUP" = "color" ] && echo -en "\\033[0;34m"
- echo -en "Fedora"
- [ "$BOOTUP" = "color" ] && echo -en "\\033[0;39m"
- PRODUCT=$(sed "s/Fedora \(.*\) \?release.*/\1/" /etc/system-release)
- echo " $PRODUCT"
-else
- PRODUCT=$(sed "s/ release.*//g" /etc/system-release)
- echo "$PRODUCT"
-fi
-if [ "$PROMPT" != "no" ]; then
- echo -en $"\t\tPress 'I' to enter interactive startup."
- echo
-fi
-:
diff --git a/rc.d/rcS.d/040-setmodprobe.sh b/rc.d/rcS.d/040-setmodprobe.sh
deleted file mode 100755
index 66003357..00000000
--- a/rc.d/rcS.d/040-setmodprobe.sh
+++ /dev/null
@@ -1,14 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
-
-# Initialize hardware
-if [ -f /proc/sys/kernel/modprobe ]; then
- if ! strstr "$cmdline" nomodules && [ -f /proc/modules ] ; then
- sysctl -w kernel.modprobe="/sbin/modprobe" >/dev/null 2>&1
- else
- # We used to set this to NULL, but that causes 'failed to exec' messages"
- sysctl -w kernel.modprobe="/bin/true" >/dev/null 2>&1
- fi
-fi
-:
diff --git a/rc.d/rcS.d/060-taskaffinity.sh b/rc.d/rcS.d/060-taskaffinity.sh
deleted file mode 100755
index c8045d40..00000000
--- a/rc.d/rcS.d/060-taskaffinity.sh
+++ /dev/null
@@ -1,15 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
-
-# Set default affinity
-if [ -x /bin/taskset ]; then
- if strstr "$cmdline" default_affinity= ; then
- for arg in $cmdline ; do
- if [ "${arg##default_affinity=}" != "${arg}" ]; then
- /bin/taskset -p ${arg##default_affinity=} 1
- fi
- done
- fi
-fi
-:
diff --git a/rc.d/rcS.d/070-startudev.sh b/rc.d/rcS.d/070-startudev.sh
deleted file mode 100755
index 04874038..00000000
--- a/rc.d/rcS.d/070-startudev.sh
+++ /dev/null
@@ -1,3 +0,0 @@
-#!/bin/sh
-/sbin/start_udev
-:
diff --git a/rc.d/rcS.d/080-devpts.sh b/rc.d/rcS.d/080-devpts.sh
deleted file mode 100755
index d2fa937a..00000000
--- a/rc.d/rcS.d/080-devpts.sh
+++ /dev/null
@@ -1,15 +0,0 @@
-#!/bin/sh
-# Check SELinux status
-SELINUX_STATE=
-if [ -e "/selinux/enforce" ] && [ "$(cat /proc/self/attr/current)" != "kernel" ]; then
- if [ -r "/selinux/enforce" ] ; then
- SELINUX_STATE=$(cat "/selinux/enforce")
- else
- # assume enforcing if you can't read it
- SELINUX_STATE=1
- fi
-fi
-
-mount -n /dev/pts >/dev/null 2>&1
-[ -n "$SELINUX_STATE" ] && restorecon /dev/pts >/dev/null 2>&1
-:
diff --git a/rc.d/rcS.d/090-loadmodules.sh b/rc.d/rcS.d/090-loadmodules.sh
deleted file mode 100755
index 4ad4bbad..00000000
--- a/rc.d/rcS.d/090-loadmodules.sh
+++ /dev/null
@@ -1,12 +0,0 @@
-#!/bin/sh
-
-# Load other user-defined modules
-for file in /etc/sysconfig/modules/*.modules ; do
- [ -x $file ] && $file
-done
-
-# Load modules (for backward compatibility with VARs)
-if [ -f /etc/rc.modules ]; then
- /etc/rc.modules
-fi
-:
diff --git a/rc.d/rcS.d/100-kernelparam.sh b/rc.d/rcS.d/100-kernelparam.sh
deleted file mode 100755
index 36728c95..00000000
--- a/rc.d/rcS.d/100-kernelparam.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-
-# Configure kernel parameters
-update_boot_stage RCkernelparam
-sysctl -e -p /etc/sysctl.conf >/dev/null 2>&1
-:
diff --git a/rc.d/rcS.d/110-waitscan.sh b/rc.d/rcS.d/110-waitscan.sh
deleted file mode 100755
index db083320..00000000
--- a/rc.d/rcS.d/110-waitscan.sh
+++ /dev/null
@@ -1,4 +0,0 @@
-#!/bin/sh
-# Sync waiting for storage.
-{ rmmod scsi_wait_scan ; modprobe scsi_wait_scan ; rmmod scsi_wait_scan ; } >/dev/null 2>&1
-:
diff --git a/rc.d/rcS.d/120-loaddmmod.sh b/rc.d/rcS.d/120-loaddmmod.sh
deleted file mode 100755
index 4696af97..00000000
--- a/rc.d/rcS.d/120-loaddmmod.sh
+++ /dev/null
@@ -1,8 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-
-# Device mapper & related initialization
-if ! __fgrep "device-mapper" /proc/devices >/dev/null 2>&1 ; then
- modprobe dm-mod >/dev/null 2>&1
-fi
-:
diff --git a/rc.d/rcS.d/130-initcrypto1.sh b/rc.d/rcS.d/130-initcrypto1.sh
deleted file mode 100755
index dd1ba876..00000000
--- a/rc.d/rcS.d/130-initcrypto1.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-
-if [ -f /etc/crypttab ]; then
- init_crypto 0
-fi
-:
diff --git a/rc.d/rcS.d/140-multipath.sh b/rc.d/rcS.d/140-multipath.sh
deleted file mode 100755
index 83fc0d8f..00000000
--- a/rc.d/rcS.d/140-multipath.sh
+++ /dev/null
@@ -1,13 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
-
-if ! strstr "$cmdline" nompath && [ -f /etc/multipath.conf ] && \
- [ -x /sbin/multipath ]; then
- modprobe dm-multipath > /dev/null 2>&1
- /sbin/multipath -v 0
- if [ -x /sbin/kpartx ]; then
- /sbin/dmsetup ls --target multipath --exec "/sbin/kpartx -a -p p" >/dev/null
- fi
-fi
-:
diff --git a/rc.d/rcS.d/150-dmraid.sh b/rc.d/rcS.d/150-dmraid.sh
deleted file mode 100755
index f983e4e9..00000000
--- a/rc.d/rcS.d/150-dmraid.sh
+++ /dev/null
@@ -1,19 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
-
-if ! strstr "$cmdline" nodmraid && [ -x /sbin/dmraid ]; then
- modprobe dm-mirror >/dev/null 2>&1
- dmraidsets=$(LC_ALL=C /sbin/dmraid -s -c -i)
- if [ "$?" = "0" ]; then
- for dmname in $dmraidsets; do
- if [[ "$dmname" == isw_* ]] && \
- ! strstr "$cmdline" noiswmd; then
- continue
- fi
- /sbin/dmraid -ay -i --rm_partitions -p "$dmname" >/dev/null 2>&1
- /sbin/kpartx -a -p p "/dev/mapper/$dmname"
- done
- fi
-fi
-:
diff --git a/rc.d/rcS.d/160-mdraid.sh b/rc.d/rcS.d/160-mdraid.sh
deleted file mode 100755
index 1a0b065e..00000000
--- a/rc.d/rcS.d/160-mdraid.sh
+++ /dev/null
@@ -1,4 +0,0 @@
-#!/bin/sh
-# Start any MD RAID arrays that haven't been started yet
-[ -r /proc/mdstat -a -r /dev/md/md-device-map ] && /sbin/mdadm -IRs
-:
diff --git a/rc.d/rcS.d/170-lvm.sh b/rc.d/rcS.d/170-lvm.sh
deleted file mode 100755
index da4bd84d..00000000
--- a/rc.d/rcS.d/170-lvm.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
-if [ -x /sbin/lvm ]; then
- action $"Setting up Logical Volume Management:" /sbin/lvm vgchange -a y --sysinit
-fi
-:
diff --git a/rc.d/rcS.d/180-initcrypto2.sh b/rc.d/rcS.d/180-initcrypto2.sh
deleted file mode 100755
index dd1ba876..00000000
--- a/rc.d/rcS.d/180-initcrypto2.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-
-if [ -f /etc/crypttab ]; then
- init_crypto 0
-fi
-:
diff --git a/rc.d/rcS.d/190-mountall.sh b/rc.d/rcS.d/190-mountall.sh
deleted file mode 100755
index ff8c6953..00000000
--- a/rc.d/rcS.d/190-mountall.sh
+++ /dev/null
@@ -1,315 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
-
-# Check SELinux status
-SELINUX_STATE=
-if [ -e "/selinux/enforce" ] && [ "$(cat /proc/self/attr/current)" != "kernel" ]; then
- if [ -r "/selinux/enforce" ] ; then
- SELINUX_STATE=$(cat "/selinux/enforce")
- else
- # assume enforcing if you can't read it
- SELINUX_STATE=1
- fi
-fi
-
-disable_selinux() {
- echo $"*** Warning -- SELinux is active"
- echo $"*** Disabling security enforcement for system recovery."
- echo $"*** Run 'setenforce 1' to reenable."
- echo "0" > "/selinux/enforce"
-}
-
-if [ -f /fsckoptions ]; then
- fsckoptions=$(cat /fsckoptions)
-fi
-
-if [ -f /forcefsck ] || strstr "$cmdline" forcefsck ; then
- fsckoptions="-f $fsckoptions"
-elif [ -f /.autofsck ]; then
- [ -f /etc/sysconfig/autofsck ] && . /etc/sysconfig/autofsck
- if [ "$AUTOFSCK_DEF_CHECK" = "yes" ]; then
- AUTOFSCK_OPT="$AUTOFSCK_OPT -f"
- fi
- if [ -n "$AUTOFSCK_SINGLEUSER" ]; then
- [ type -p plymouth &>/dev/null ] && plymouth --hide-splash
- echo
- echo $"*** Warning -- the system did not shut down cleanly. "
- echo $"*** Dropping you to a shell; the system will continue"
- echo $"*** when you leave the shell."
- [ -n "$SELINUX_STATE" ] && echo "0" > /selinux/enforce
- sulogin
- [ -n "$SELINUX_STATE" ] && echo "1" > /selinux/enforce
- [ type -p plymouth &>/dev/null ] && plymouth --show-splash
- fi
- fsckoptions="$AUTOFSCK_OPT $fsckoptions"
-fi
-
-if [ "$BOOTUP" = "color" ]; then
- fsckoptions="-C $fsckoptions"
-else
- fsckoptions="-V $fsckoptions"
-fi
-
-READONLY=no
-if [ -f /etc/sysconfig/readonly-root ]; then
- . /etc/sysconfig/readonly-root
-fi
-if strstr "$cmdline" readonlyroot ; then
- READONLY=yes
- [ -z "$RW_MOUNT" ] && RW_MOUNT=/var/lib/stateless/writable
- [ -z "$STATE_MOUNT" ] && STATE_MOUNT=/var/lib/stateless/state
-fi
-if strstr "$cmdline" noreadonlyroot ; then
- READONLY=no
-fi
-
-if [ "$READONLY" = "yes" -o "$TEMPORARY_STATE" = "yes" ]; then
-
- mount_empty() {
- if [ -e "$1" ]; then
- echo "$1" | cpio -p -vd "$RW_MOUNT" &>/dev/null
- mount -n --bind "$RW_MOUNT$1" "$1"
- fi
- }
-
- mount_dirs() {
- if [ -e "$1" ]; then
- mkdir -p "$RW_MOUNT$1"
- find "$1" -type d -print0 | cpio -p -0vd "$RW_MOUNT" &>/dev/null
- mount -n --bind "$RW_MOUNT$1" "$1"
- fi
- }
-
- mount_files() {
- if [ -e "$1" ]; then
- cp -a --parents "$1" "$RW_MOUNT"
- mount -n --bind "$RW_MOUNT$1" "$1"
- fi
- }
-
- # Common mount options for scratch space regardless of
- # type of backing store
- mountopts=
-
- # Scan partitions for local scratch storage
- rw_mount_dev=$(blkid -t LABEL="$RW_LABEL" -l -o device)
-
- # First try to mount scratch storage from /etc/fstab, then any
- # partition with the proper label. If either succeeds, be sure
- # to wipe the scratch storage clean. If both fail, then mount
- # scratch storage via tmpfs.
- if mount $mountopts "$RW_MOUNT" > /dev/null 2>&1 ; then
- rm -rf "$RW_MOUNT" > /dev/null 2>&1
- elif [ x$rw_mount_dev != x ] && mount $rw_mount_dev $mountopts "$RW_MOUNT" > /dev/null 2>&1; then
- rm -rf "$RW_MOUNT" > /dev/null 2>&1
- else
- mount -n -t tmpfs $RW_OPTIONS $mountopts none "$RW_MOUNT"
- fi
-
- for file in /etc/rwtab /etc/rwtab.d/* /dev/.initramfs/rwtab ; do
- is_ignored_file "$file" && continue
- [ -f $file ] && cat $file | while read type path ; do
- case "$type" in
- empty)
- mount_empty $path
- ;;
- files)
- mount_files $path
- ;;
- dirs)
- mount_dirs $path
- ;;
- *)
- ;;
- esac
- [ -n "$SELINUX_STATE" ] && [ -e "$path" ] && restorecon -R "$path"
- done
- done
-
- # Use any state passed by initramfs
- [ -d /dev/.initramfs/state ] && cp -a /dev/.initramfs/state/* $RW_MOUNT
-
- # In theory there should be no more than one network interface active
- # this early in the boot process -- the one we're booting from.
- # Use the network address to set the hostname of the client. This
- # must be done even if we have local storage.
- ipaddr=
- if [ "$HOSTNAME" = "localhost" -o "$HOSTNAME" = "localhost.localdomain" ]; then
- ipaddr=$(ip addr show to 0.0.0.0/0 scope global | awk '/[[:space:]]inet / { print gensub("/.*","","g",$2) }')
- for ip in $ipaddr ; do
- HOSTNAME=
- eval $(ipcalc -h $ipaddr 2>/dev/null)
- [ -n "$HOSTNAME" ] && { hostname ${HOSTNAME} ; break; }
- done
- fi
-
- # Clients with read-only root filesystems may be provided with a
- # place where they can place minimal amounts of persistent
- # state. SSH keys or puppet certificates for example.
- #
- # Ideally we'll use puppet to manage the state directory and to
- # create the bind mounts. However, until that's all ready this
- # is sufficient to build a working system.
-
- # First try to mount persistent data from /etc/fstab, then any
- # partition with the proper label, then fallback to NFS
- state_mount_dev=$(blkid -t LABEL="$STATE_LABEL" -l -o device)
- if mount $mountopts $STATE_OPTIONS "$STATE_MOUNT" > /dev/null 2>&1 ; then
- /bin/true
- elif [ x$state_mount_dev != x ] && mount $state_mount_dev $mountopts "$STATE_MOUNT" > /dev/null 2>&1; then
- /bin/true
- elif [ ! -z "$CLIENTSTATE" ]; then
- # No local storage was found. Make a final attempt to find
- # state on an NFS server.
-
- mount -t nfs $CLIENTSTATE/$HOSTNAME $STATE_MOUNT -o rw,nolock
- fi
-
- if [ -w "$STATE_MOUNT" ]; then
-
- mount_state() {
- if [ -e "$1" ]; then
- [ ! -e "$STATE_MOUNT$1" ] && cp -a --parents "$1" "$STATE_MOUNT"
- mount -n --bind "$STATE_MOUNT$1" "$1"
- fi
- }
-
- for file in /etc/statetab /etc/statetab.d/* ; do
- is_ignored_file "$file" && continue
- [ ! -f "$file" ] && continue
-
- if [ -f "$STATE_MOUNT/$file" ] ; then
- mount -n --bind "$STATE_MOUNT/$file" "$file"
- fi
-
- for path in $(grep -v "^#" "$file" 2>/dev/null); do
- mount_state "$path"
- [ -n "$SELINUX_STATE" ] && [ -e "$path" ] && restorecon -R "$path"
- done
- done
-
- if [ -f "$STATE_MOUNT/files" ] ; then
- for path in $(grep -v "^#" "$STATE_MOUNT/files" 2>/dev/null); do
- mount_state "$path"
- [ -n "$SELINUX_STATE" ] && [ -e "$path" ] && restorecon -R "$path"
- done
- fi
- fi
-fi
-
-if [[ " $fsckoptions" != *" -y"* ]]; then
- fsckoptions="-a $fsckoptions"
-fi
-
-if [ -f /fastboot ] || strstr "$cmdline" fastboot ; then
- fastboot=yes
-fi
-if [ -z "$fastboot" -a "$READONLY" != "yes" ]; then
-
- STRING=$"Checking filesystems"
- echo $STRING
- fsck -T -t noopts=_netdev -A $fsckoptions
- rc=$?
-
- if [ "$rc" -eq "0" ]; then
- success "$STRING"
- echo
- elif [ "$rc" -eq "1" ]; then
- passed "$STRING"
- echo
- elif [ "$rc" -eq "2" -o "$rc" -eq "3" ]; then
- echo $"Unmounting file systems"
- umount -a
- mount -n -o remount,ro /
- echo $"Automatic reboot in progress."
- reboot -f
- fi
-
- # A return of 4 or higher means there were serious problems.
- if [ $rc -gt 1 ]; then
- [ type -p plymouth &>/dev/null ] && plymouth --hide-splash
-
- failure "$STRING"
- echo
- echo
- echo $"*** An error occurred during the file system check."
- echo $"*** Dropping you to a shell; the system will reboot"
- echo $"*** when you leave the shell."
-
- str=$"(Repair filesystem)"
- PS1="$str \# # "; export PS1
- [ "$SELINUX_STATE" = "1" ] && disable_selinux
- sulogin
-
- echo $"Unmounting file systems"
- umount -a
- mount -n -o remount,ro /
- echo $"Automatic reboot in progress."
- reboot -f
- elif [ "$rc" -eq "1" ]; then
- _RUN_QUOTACHECK=1
- fi
-fi
-
-remount_needed() {
- local state oldifs
- [ "$READONLY" = "yes" ] && return 1
- state=$(LC_ALL=C awk '/ \/ / && ($3 !~ /rootfs/) { print $4 }' /proc/mounts)
- oldifs=$IFS
- IFS=","
- for opt in $state ; do
- if [ "$opt" = "rw" ]; then
- IFS=$oldifs
- return 1
- fi
- done
- IFS=$oldifs
- return 0
-}
-
-# Remount the root filesystem read-write.
-update_boot_stage RCmountfs
-if remount_needed ; then
- action $"Remounting root filesystem in read-write mode: " mount -n -o remount,rw /
-fi
-
-# Clean up SELinux labels
-if [ -n "$SELINUX_STATE" ]; then
- restorecon /etc/mtab /etc/ld.so.cache /etc/blkid/blkid.tab /etc/resolv.conf >/dev/null 2>&1
-fi
-
-# If relabeling, relabel mount points.
-if [ -n "$SELINUX_STATE" -a "$READONLY" != "yes" ]; then
- if strstr "$cmdline" autorelabel || [ -f /.autorelabel ] ; then
- restorecon $(awk '!/^#/ && $4 !~ /noauto/ && $2 ~ /^\// { print $2 }' /etc/fstab) >/dev/null 2>&1
- fi
-fi
-
-if [ "$READONLY" != "yes" ] ; then
- # Clear mtab
- (> /etc/mtab) &> /dev/null
-
- # Remove stale backups
- rm -f /etc/mtab~ /etc/mtab~~
-
- # Enter mounted filesystems into /etc/mtab
- mount -f /
- mount -f /proc >/dev/null 2>&1
- mount -f /sys >/dev/null 2>&1
- mount -f /dev/pts >/dev/null 2>&1
- mount -f /dev/shm >/dev/null 2>&1
- mount -f /proc/bus/usb >/dev/null 2>&1
-fi
-
-# Mount all other filesystems (except for NFS and /proc, which is already
-# mounted). Contrary to standard usage,
-# filesystems are NOT unmounted in single user mode.
-if [ "$READONLY" != "yes" ] ; then
- action $"Mounting local filesystems: " mount -a -t nonfs,nfs4,smbfs,ncpfs,cifs,gfs,gfs2 -O no_netdev
-else
- action $"Mounting local filesystems: " mount -a -n -t nonfs,nfs4,smbfs,ncpfs,cifs,gfs,gfs2 -O no_netdev
-fi
-
-[[ $_RUN_QUOTACHECK = 1 ]] && touch /forcequotacheck
-:
diff --git a/rc.d/rcS.d/200-quota.sh b/rc.d/rcS.d/200-quota.sh
deleted file mode 100755
index bc7ee758..00000000
--- a/rc.d/rcS.d/200-quota.sh
+++ /dev/null
@@ -1,12 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
-
-if [ -x /sbin/quotacheck ] && { strstr "$cmdline" forcequotacheck || [ -f /forcequotacheck ]; } ; then
- action $"Checking local filesystem quotas: " /sbin/quotacheck -anug
-fi
-
-if [ -x /sbin/quotaon ]; then
- action $"Enabling local filesystem quotas: " /sbin/quotaon -aug
-fi
-:
diff --git a/rc.d/rcS.d/210-selinuxrelabel.sh b/rc.d/rcS.d/210-selinuxrelabel.sh
deleted file mode 100755
index 9ce86d9a..00000000
--- a/rc.d/rcS.d/210-selinuxrelabel.sh
+++ /dev/null
@@ -1,74 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
-
-READONLY=no
-if [ -f /etc/sysconfig/readonly-root ]; then
- . /etc/sysconfig/readonly-root
-fi
-if strstr "$cmdline" readonlyroot ; then
- READONLY=yes
- [ -z "$RW_MOUNT" ] && RW_MOUNT=/var/lib/stateless/writable
- [ -z "$STATE_MOUNT" ] && STATE_MOUNT=/var/lib/stateless/state
-fi
-if strstr "$cmdline" noreadonlyroot ; then
- READONLY=no
-fi
-
-# Check SELinux status
-SELINUX_STATE=
-if [ -e "/selinux/enforce" ] && [ "$(cat /proc/self/attr/current)" != "kernel" ]; then
- if [ -r "/selinux/enforce" ] ; then
- SELINUX_STATE=$(cat "/selinux/enforce")
- else
- # assume enforcing if you can't read it
- SELINUX_STATE=1
- fi
-fi
-
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
-
-relabel_selinux() {
- # if /sbin/init is not labeled correctly this process is running in the
- # wrong context, so a reboot will be required after relabel
- AUTORELABEL=
- . /etc/selinux/config
- echo "0" > /selinux/enforce
- [ type -p plymouth &>/dev/null ] && plymouth --hide-splash
-
- if [ "$AUTORELABEL" = "0" ]; then
- echo
- echo $"*** Warning -- SELinux ${SELINUXTYPE} policy relabel is required. "
- echo $"*** /etc/selinux/config indicates you want to manually fix labeling"
- echo $"*** problems. Dropping you to a shell; the system will reboot"
- echo $"*** when you leave the shell."
- sulogin
-
- else
- echo
- echo $"*** Warning -- SELinux ${SELINUXTYPE} policy relabel is required."
- echo $"*** Relabeling could take a very long time, depending on file"
- echo $"*** system size and speed of hard drives."
-
- /sbin/fixfiles -F restore > /dev/null 2>&1
- fi
- rm -f /.autorelabel
- echo $"Unmounting file systems"
- umount -a
- mount -n -o remount,ro /
- echo $"Automatic reboot in progress."
- reboot -f
-}
-
-# Check to see if a full relabel is needed
-if [ -n "$SELINUX_STATE" -a "$READONLY" != "yes" ]; then
- if strstr "$cmdline" autorelabel || [ -f /.autorelabel ] ; then
- relabel_selinux
- fi
-else
- if [ "$READONLY" != "yes" ] && [ -d /etc/selinux ]; then
- [ -f /.autorelabel ] || touch /.autorelabel
- fi
-fi
-:
diff --git a/rc.d/rcS.d/220-random.sh b/rc.d/rcS.d/220-random.sh
deleted file mode 100755
index fa1102ad..00000000
--- a/rc.d/rcS.d/220-random.sh
+++ /dev/null
@@ -1,28 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
-
-READONLY=no
-if [ -f /etc/sysconfig/readonly-root ]; then
- . /etc/sysconfig/readonly-root
-fi
-if strstr "$cmdline" readonlyroot ; then
- READONLY=yes
- [ -z "$RW_MOUNT" ] && RW_MOUNT=/var/lib/stateless/writable
- [ -z "$STATE_MOUNT" ] && STATE_MOUNT=/var/lib/stateless/state
-fi
-if strstr "$cmdline" noreadonlyroot ; then
- READONLY=no
-fi
-
-# Initialize pseudo-random number generator
-if [ -f "/var/lib/random-seed" ]; then
- cat /var/lib/random-seed > /dev/urandom
-else
- [ "$READONLY" != "yes" ] && touch /var/lib/random-seed
-fi
-if [ "$READONLY" != "yes" ]; then
- chmod 600 /var/lib/random-seed
- dd if=/dev/urandom of=/var/lib/random-seed count=1 bs=512 2>/dev/null
-fi
-:
diff --git a/rc.d/rcS.d/230-initcrypto3.sh b/rc.d/rcS.d/230-initcrypto3.sh
deleted file mode 100755
index d7e7b757..00000000
--- a/rc.d/rcS.d/230-initcrypto3.sh
+++ /dev/null
@@ -1,7 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-
-if [ -f /etc/crypttab ]; then
- init_crypto 1
-fi
-:
diff --git a/rc.d/rcS.d/240-configure.sh b/rc.d/rcS.d/240-configure.sh
deleted file mode 100755
index 7cf87796..00000000
--- a/rc.d/rcS.d/240-configure.sh
+++ /dev/null
@@ -1,39 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-
-# Configure machine if necessary.
-if [ -f /.unconfigured ]; then
- if [ -x /usr/bin/rhgb-client ] && /usr/bin/rhgb-client --ping ; then
- /usr/bin/rhgb-client --quit
- fi
-
- if [ -x /usr/bin/system-config-keyboard ]; then
- /usr/bin/system-config-keyboard
- fi
- if [ -x /usr/bin/passwd ]; then
- /usr/bin/passwd root
- fi
- if [ -x /usr/sbin/system-config-network-tui ]; then
- /usr/sbin/system-config-network-tui
- fi
- if [ -x /usr/sbin/timeconfig ]; then
- /usr/sbin/timeconfig
- fi
- if [ -x /usr/sbin/authconfig-tui ]; then
- /usr/sbin/authconfig-tui --nostart
- fi
- if [ -x /usr/sbin/ntsysv ]; then
- /usr/sbin/ntsysv --level 35
- fi
-
- # Reread in network configuration data.
- if [ -f /etc/sysconfig/network ]; then
- . /etc/sysconfig/network
-
- # Reset the hostname.
- action $"Resetting hostname ${HOSTNAME}: " hostname ${HOSTNAME}
- fi
-
- rm -f /.unconfigured
-fi
-:
diff --git a/rc.d/rcS.d/250-cleanup.sh b/rc.d/rcS.d/250-cleanup.sh
deleted file mode 100755
index 0b4de0fb..00000000
--- a/rc.d/rcS.d/250-cleanup.sh
+++ /dev/null
@@ -1,57 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
-
-# Check SELinux status
-SELINUX_STATE=
-if [ -e "/selinux/enforce" ] && [ "$(cat /proc/self/attr/current)" != "kernel" ]; then
- if [ -r "/selinux/enforce" ] ; then
- SELINUX_STATE=$(cat "/selinux/enforce")
- else
- # assume enforcing if you can't read it
- SELINUX_STATE=1
- fi
-fi
-
-# Clean out /.
-rm -f /fastboot /fsckoptions /forcefsck /.autofsck /forcequotacheck /halt \
- /poweroff /.suspended &> /dev/null
-
-# Do we need (w|u)tmpx files? We don't set them up, but the sysadmin might...
-_NEED_XFILES=
-[ -f /var/run/utmpx ] || [ -f /var/log/wtmpx ] && _NEED_XFILES=1
-
-# Clean up /var.
-rm -rf /var/lock/cvs/* /var/run/screen/*
-find /var/lock /var/run ! -type d -exec rm -f {} \;
-rm -f /var/lib/rpm/__db* &> /dev/null
-rm -f /var/gdm/.gdmfifo &> /dev/null
-
-
-# Clean up utmp/wtmp
-> /var/run/utmp
-touch /var/log/wtmp /var/log/btmp
-chgrp utmp /var/run/utmp /var/log/wtmp /var/log/btmp
-chmod 0664 /var/run/utmp /var/log/wtmp
-chmod 0600 /var/log/btmp
-if [ -n "$_NEED_XFILES" ]; then
- > /var/run/utmpx
- touch /var/log/wtmpx
- chgrp utmp /var/run/utmpx /var/log/wtmpx
- chmod 0664 /var/run/utmpx /var/log/wtmpx
-fi
-[ -n "$SELINUX_STATE" ] && restorecon /var/run/utmp* /var/log/wtmp* >/dev/null 2>&1
-
-# Clean up various /tmp bits
-[ -n "$SELINUX_STATE" ] && restorecon /tmp
-rm -f /tmp/.X*-lock /tmp/.lock.* /tmp/.gdm_socket /tmp/.s.PGSQL.*
-rm -rf /tmp/.X*-unix /tmp/.ICE-unix /tmp/.font-unix /tmp/hsperfdata_* \
- /tmp/kde-* /tmp/ksocket-* /tmp/mc-* /tmp/mcop-* /tmp/orbit-* \
- /tmp/scrollkeeper-* /tmp/ssh-* \
- /dev/.in_sysinit
-
-# Make ICE directory
-mkdir -m 1777 -p /tmp/.ICE-unix >/dev/null 2>&1
-chown root:root /tmp/.ICE-unix
-[ -n "$SELINUX_STATE" ] && restorecon /tmp/.ICE-unix >/dev/null 2>&1
-:
diff --git a/rc.d/rcS.d/260-swap.sh b/rc.d/rcS.d/260-swap.sh
deleted file mode 100755
index 51a55f39..00000000
--- a/rc.d/rcS.d/260-swap.sh
+++ /dev/null
@@ -1,8 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-
-# Start up swapping.
-update_boot_stage RCswap
-action $"Enabling /etc/fstab swaps: " swapon -a -e
-
-:
diff --git a/rc.d/rcS.d/270-autoswap.sh b/rc.d/rcS.d/270-autoswap.sh
deleted file mode 100755
index e7ce922e..00000000
--- a/rc.d/rcS.d/270-autoswap.sh
+++ /dev/null
@@ -1,16 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-
-# Start up swapping.
-if [ "$AUTOSWAP" = "yes" ]; then
- curswap=$(awk '/^\/dev/ { print $1 }' /proc/swaps | while read x; do get_numeric_dev dec $x ; echo -n " "; done)
- swappartitions=$(blkid -t TYPE=swap -o device)
- if [ x"$swappartitions" != x ]; then
- for partition in $swappartitions ; do
- [ ! -e $partition ] && continue
- majmin=$(get_numeric_dev dec $partition)
- echo $curswap | grep -qw "$majmin" || action $"Enabling local swap partitions: " swapon $partition
- done
- fi
-fi
-:
diff --git a/rc.d/rcS.d/300-binfmtmisc.sh b/rc.d/rcS.d/300-binfmtmisc.sh
deleted file mode 100755
index b27148af..00000000
--- a/rc.d/rcS.d/300-binfmtmisc.sh
+++ /dev/null
@@ -1,4 +0,0 @@
-#!/bin/sh
-# Set up binfmt_misc
-/bin/mount -t binfmt_misc none /proc/sys/fs/binfmt_misc > /dev/null 2>&1
-:
diff --git a/rc.d/rcS.d/310-autofsck.sh b/rc.d/rcS.d/310-autofsck.sh
deleted file mode 100755
index ebf8717a..00000000
--- a/rc.d/rcS.d/310-autofsck.sh
+++ /dev/null
@@ -1,4 +0,0 @@
-#!/bin/sh
-# create the crash indicator flag to warn on crashes, offer fsck with timeout
-touch /.autofsck &> /dev/null
-:
diff --git a/rc.d/rcS.d/320-getkey.sh b/rc.d/rcS.d/320-getkey.sh
deleted file mode 100755
index f70cb5c0..00000000
--- a/rc.d/rcS.d/320-getkey.sh
+++ /dev/null
@@ -1,8 +0,0 @@
-#!/bin/sh
-[[ $(type -t strstr) = "function" ]] || . /etc/init.d/functions
-[[ $cmdline ]] || cmdline=$(cat /proc/cmdline)
-
-if strstr "$cmdline" confirm ; then
- touch /var/run/confirm
-fi
-:
diff --git a/rc.d/rcS.d/330-dmesg.sh b/rc.d/rcS.d/330-dmesg.sh
deleted file mode 100755
index 42fb0efe..00000000
--- a/rc.d/rcS.d/330-dmesg.sh
+++ /dev/null
@@ -1,6 +0,0 @@
-#!/bin/sh
-# Now that we have all of our basic modules loaded and the kernel going,
-# let's dump the syslog ring somewhere so we can find it later
-[ -f /var/log/dmesg ] && mv -f /var/log/dmesg /var/log/dmesg.old
-dmesg -s 131072 > /var/log/dmesg
-:
diff --git a/rc.d/rcS.d/990-sysinitend.sh b/rc.d/rcS.d/990-sysinitend.sh
deleted file mode 100755
index f79d0995..00000000
--- a/rc.d/rcS.d/990-sysinitend.sh
+++ /dev/null
@@ -1,6 +0,0 @@
-#!/bin/sh
-# Let rhgb know that we're leaving rc.sysinit
-if [ -x /usr/bin/rhgb-client ] && /usr/bin/rhgb-client --ping ; then
- /usr/bin/rhgb-client --sysinit
-fi
-: